/*
 * This file is part of TechReborn, licensed under the MIT License (MIT).
 *
 * Copyright (c) 2018 TechReborn
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

package techreborn.utils;

import net.minecraft.class_1792;
import net.minecraft.class_1799;
import net.minecraft.class_2248;
import net.minecraft.class_2371;
import net.minecraft.class_2378;
import net.minecraft.class_2960;
import net.minecraft.class_3414;
import reborncore.RebornRegistry;
import reborncore.api.power.ItemPowerManager;
import techreborn.TechReborn;

public class InitUtils {
	public static <I extends class_1792> I setup(I item, String name) {
		RebornRegistry.registerIdent(item, new class_2960(TechReborn.MOD_ID, name));
		return item;
	}

	public static <B extends class_2248> B setup(B block, String name) {
		RebornRegistry.registerIdent(block, new class_2960(TechReborn.MOD_ID, name));
		return block;
	}
	
	public static class_3414 setup(String name) {
		class_2960 identifier = new class_2960(TechReborn.MOD_ID, name);
		return class_2378.method_10230(class_2378.field_11156, identifier, new class_3414(identifier));
	}
	
	public static void initPoweredItems(class_1792 item, class_2371<class_1799> itemList) {
		class_1799 uncharged = new class_1799(item);
		class_1799 charged = new class_1799(item);
		ItemPowerManager capEnergy = new ItemPowerManager(charged);
		capEnergy.setEnergyStored(capEnergy.getMaxEnergyStored());

		itemList.add(uncharged);
		itemList.add(charged);
	}
}
